#include "StdAfx.h"
#include "Tool.h"
#include "fname.h"

#define MSG_TITLE L"mF - Cinema"

int DoMessage(HWND hWnd, LPCWSTR a)
{
	return MessageBox(hWnd, a, MSG_TITLE, MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
}

int DoMessageOC(HWND hWnd, LPCWSTR a)
{
	return MessageBox(hWnd, a, MSG_TITLE, MB_OKCANCEL | MB_ICONQUESTION | MB_SYSTEMMODAL);
}

void DbgMessage(HWND hWnd,int nInteger)
{
	wchar_t buf[255];
	swprintf_s(buf, 15, L"%d", nInteger);
	SetWindowText(hWnd, buf);
}

int FontDlg(HWND hwnd, LOGFONT *plf)
{
	CHOOSEFONT cf;
	ZeroMemory(&cf, sizeof(CHOOSEFONT));
	cf.lStructSize  = sizeof(CHOOSEFONT);
	cf.hwndOwner	= hwnd;
	cf.lpLogFont    = plf;
	cf.nFontType    = REGULAR_FONTTYPE;
	cf.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;// | CF_NOSTYLESEL | CF_USESTYLE;
	if (ChooseFont(&cf))
	{
		return cf.iPointSize / 10;
	}
	return 0;
}
