// y901w.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "y901w.h"
#include "fname.h"
#include "DirectA.h"

#define MAX_LOADSTRING 100
#define IDW_DIRECT 1008

C901 *y901w;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	return y901w->WndProc(hWnd, message, wParam, lParam);
}

int APIENTRY wWinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPWSTR lpCmd, int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrev);
	UNREFERENCED_PARAMETER(lpCmd);

	MSG msg;
	HACCEL hAccelTable;
	wchar_t szTitle[MAX_LOADSTRING];				// ^Cg o[̃eLXg
	wchar_t szWindowClass[MAX_LOADSTRING];			// C EBhE NX
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_Y901W, szWindowClass, MAX_LOADSTRING);
	//dNh~
	HWND hw = FindWindow(szWindowClass, NULL);
	if (hw != NULL)
	{
		//֘AÂȌꍇ͓ꂽق
		HANDLE hMutex = ::CreateMutex(NULL, TRUE, L"Y901w_Mutex");
		if (::GetLastError() == ERROR_ALREADY_EXISTS)
		{
			::ReleaseMutex(hMutex);
			::CloseHandle(hMutex);
			return 0;
		}
		::ReleaseMutex(hMutex);
		::CloseHandle(hMutex);
		//ŏĂꍇ̏
		if (IsIconic(hw))
			OpenIcon(hw);
		else
			::SetForegroundWindow(hw);
		//󂯓n
		COPYDATASTRUCT cds;
		cds.dwData = 1;
		cds.cbData = 1024;//lstrlen(__wagv[1])+1;
		cds.lpData = (LPVOID)__wargv[1];
		::SendMessage(hw, WM_COPYDATA, 0, (LPARAM)&cds);
		return 0;
	}
	// RegisterClass
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_Y901W));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= CreateSolidBrush(0xff000000);// for dwm
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_Y901W);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;
	RegisterClassEx(&wcex);
	// GdiPlus
	GdiplusStartupInput gdiplusStartupInput;
	ULONG_PTR gdiplusToken;
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	// Create
	y901w = new C901(hInstance);
	HWND hWnd;
	hWnd = CreateWindowEx(
		WS_EX_ACCEPTFILES,
		szWindowClass,
		szTitle,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		0, CW_USEDEFAULT, 0, NULL, NULL,
		hInstance, NULL);
	if (!hWnd) return 1;
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_Y901W));

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	delete y901w;
	GdiplusShutdown(gdiplusToken);
	return (int) msg.wParam;
}

LRESULT C901::WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	//PAINTSTRUCT ps;
	//HDC hdc;
	RECT rc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	/*case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;*/
	case WM_CREATE:
		OnCreate(hWnd);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_DROPFILES:
		OnDropFile((HDROP)wParam);
		break;
	case WM_SIZE:
		::GetClientRect(hWnd, &rc);
		DirectA->SetVideoSize(rc);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

C901::C901(HINSTANCE hInst)
{
	hInstance = hInst;
}

void C901::OnCreate(HWND hwnd)
{
	this->hWnd = hwnd;
	DirectA = new CDirectA(hWnd, hInstance, IDW_DIRECT);
}

void C901::OnDropFile(HDROP hDrop)
{
	wchar_t szFileName[1024];
	DragQueryFile(hDrop, 0, szFileName, sizeof(szFileName));
	if (fname::FileExists(szFileName))
	{
		//SetPlayFileInfo(L"c:\\a\\a"); //gq̂ŃNAɂȂ
		DirectA->SetURL(hWnd, szFileName);
	}
	DragFinish(hDrop);
}